package com.brilliance.common.controller;

import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.isc.bo.Txm;
import com.brilliance.isc.mda.dao.TxmMapper;
import com.brilliance.isc.vo.ResponseSet;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestBody;

import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import java.util.List;
import java.util.Map;

@Component
@Consumes("application/json")
@Produces("application/json")
@Path("/txm")
public class TxmController {
        @Autowired
        private TxmMapper txmMapper;
        @POST
        @Path("/getTxmBlock")
        public ResponseSet getTxmBlock(@RequestBody Map<String, Object> map) {
            String extkey = map.get("extkey").toString();
            String trnname = map.get("trnname").toString();
            String uil = map.get("uil").toString();
            if ("CPTOPN".equalsIgnoreCase(trnname)) {
                extkey = extkey + "acc";
                List<Txm> txms = txmMapper.selectByExtkeyAndUil(extkey, uil);
                for(int i=0;i<txms.size();i++){
                    if(MdaUtils.compareTo(txms.get(i).getUil(),"CN")==0){
                        txms.get(i).setUil("Chinese");
                    }else{
                        txms.get(i).setUil("English");
                    }
                }
                return ResponseSet.simpleSuccess(txms);
            } else {
                // special process
                extkey = specialProcessForExtkey(extkey);
                List<Txm> txmList = txmMapper.selectByExtkeyAndUil(extkey,"EN");
                for(int i=0;i<txmList.size();i++){
                    if(MdaUtils.compareTo(txmList.get(i).getUil(),"CN")==0){
                        txmList.get(i).setUil("Chinese");
                    }else{
                        txmList.get(i).setUil("English");
                    }
                }
                return ResponseSet.simpleSuccess(txmList);
            }
        }

    /**
     * special process for extkey<br>
     * eg. :it seems that extkey must be 6 length, dftat need complement with "t"?
     *
     * @param extkey
     * @return
     */
    private String specialProcessForExtkey(String extkey) {
        // draft at
        if(extkey.equalsIgnoreCase("dftat.")){
            extkey = "dftatt.";
        }
        // Details of Charges
        if(extkey.equalsIgnoreCase("feetxt.")){
            extkey = "charia.";
        }

        // Settlement Instructions for this Document Set, in Litdck Docpre界面
        if (extkey.equalsIgnoreCase("setinsbr.")) {
            extkey = "setins.";
        }

        // Settlement Instructions for this Document Set, in LETDRV Disins界面
        if (extkey.equalsIgnoreCase("setinsbe.")) {
            extkey = "payins.";
        }

        // Payment instructions to ISS/AVB, in betrcl rclp界面
        if (extkey.equalsIgnoreCase("payinstxt.")) {
            extkey = "payins.";
        }

        // brtudp.tag72add
        if (extkey.equalsIgnoreCase("tag72add.")) {
            extkey = "acctag.";
        }

        return extkey;
    }
}
