package com.brilliance.isc.basesel.cptsel.resource;

import com.brilliance.isc.basesel.cptsel.service.FxtselService;
import com.brilliance.isc.basesel.trncod.service.TrncodService;
import com.brilliance.isc.vo.ResponseSet;
import com.brilliance.isc.vo.TrnCodeQueryVo;
import com.brilliance.isc.vo.funds.FxtselQueryVo;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import java.util.Map;

@RestController
@RequestMapping("/fxtsel")
public class FxtselController {

    @Resource
    private FxtselService fxtselService;
    @Resource
    private TrncodService trncodService;
    /**
     * 汇款页签查询
     * @param cptselQueryVo
     * @return
     */
    @RequestMapping("/listfxd")
    public ResponseSet list(@RequestBody FxtselQueryVo cptselQueryVo) {
        return ResponseSet.simpleSuccess(fxtselService.list(cptselQueryVo));
    }
    /**
     * 处理按钮查看能够进行的交易
     */
    @RequestMapping("/dealWithByInr")
    public ResponseSet dealWithByInr(@RequestBody TrnCodeQueryVo trnCodeQueryVo) {
        return ResponseSet.simpleSuccess(trncodService.dealWithByInr(trnCodeQueryVo));
    }

    /**
     * 详情页面初始化
     */

    @RequestMapping("/selectXxdByPrimaryKey")
    public ResponseSet selectXxdByPrimaryKey(Map<String,String> map){
        return ResponseSet.simpleSuccess(trncodService.selectXxdByPrimaryKey(map));
    }

}
